#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <time.h>
#include "kocky.h"

typedef struct { char Plan[50][25]; int R,C; int this,next; int score,lines,moves; int thisr,thisc; } THra;

int child;
THra Hra;
struct timeval zaciatok,teraz;
char nazov_kocky[7]={'o','j','l','z','s','i','t'};
int SILENT=0;

void Kresli(THra *Hra){
  int i,j;
  double bubu;
  gettimeofday(&teraz,NULL);
  bubu=(teraz.tv_sec-zaciatok.tv_sec); bubu+=((double)(teraz.tv_usec-zaciatok.tv_usec))/1000000.0;
  for (i=0;i<Hra->R;i++) {
    fprintf(stderr,"#");
    for (j=0;j<Hra->C;j++) {
      fprintf(stderr,"%c",Hra->Plan[i][j]?Hra->Plan[i][j]:(i>3?' ':'.'));
    }
    fprintf(stderr,"#");
    switch(i){
      case 3: fprintf(stderr," score: %d",Hra->score); break;
      case 4: fprintf(stderr," lines: %d",Hra->lines); break;
      case 5: fprintf(stderr," moves: %d",Hra->moves); break;
      case 6: fprintf(stderr," time: %.2f",bubu); break;
      case 8: fprintf(stderr," next: %c",nazov_kocky[Hra->this/4]); break;
    }
    fprintf(stderr,"\n");
  }
  for (j=0;j<Hra->C+2;j++) fprintf(stderr,"#"); fprintf(stderr,"\n\n");
}

void NovaHra(THra *Hra){
  int i;
  bzero(Hra->Plan,sizeof(Hra->Plan));
  Hra->R=HLBKA_SACHTY; Hra->C=SIRKA_SACHTY; for (i=0;i<Hra->C;i++) Hra->Plan[Hra->R][i]='x';
  srand(time(NULL));
  Hra->this=(rand()%7)*4;
  Hra->next=(rand()%7)*4;
  Hra->score=Hra->lines=Hra->moves=0;
  Hra->thisr=Hra->thisc=0;
  gettimeofday(&zaciatok,NULL);
  
  printf("nova hra %d %d\n",Hra->R,Hra->C);
  
  if (!SILENT) Kresli(Hra);
}

int JeKoniecHry(THra *Hra){ 
  int i,j;
  for (i=0;i<4;i++) for (j=0;j<Hra->C;j++) if (Hra->Plan[i][j]) return 1;
  return 0;
}

void KoniecHry(THra *Hra){
  double bubu;
  
  gettimeofday(&teraz,NULL);
  bubu=(teraz.tv_sec-zaciatok.tv_sec); bubu+=((double)(teraz.tv_usec-zaciatok.tv_usec))/1000000.0;
  
  Hra->this=Hra->next; // aby nepisal warning ;))
  fprintf(stderr,"GAME OVER.\n");
  fprintf(stderr,"skore:%d, riadkov:%d, kociek:%d, cas:%.3f\n",Hra->score,Hra->lines,Hra->moves,bubu);
  printf("-1 -1\n");
  wait(NULL);
  exit(0);
}

void SpracujTah(THra *Hra) {
  char tah[1000];
  int tt,kr,kc,i,j,ok,nju;
  
  if (JeKoniecHry(Hra)) KoniecHry(Hra);
  printf("%d %d\n",Hra->this,Hra->next); 
  Hra->moves++;
  
  if (!fgets(tah,997,stdin)) { 
    fprintf(stderr,"Hrac samovolne umrel :(\n"); 
    KoniecHry(Hra);
  }
  tah[strlen(tah)-1]=0;
  if (!SILENT) fprintf(stderr,"tah %d: '%s'\n",Hra->moves,tah);
  for (tt=0;tt<(int)strlen(tah);tt++) {
    switch (tah[tt]){
      case 'L': 
        ok=1; 
        for (i=0;i<4;i++) for (j=0;j<4;j++) if ((Hra->thisc)+j-1<0) if (KOCKA[Hra->this][i][j]!='.') ok=0;
        Hra->thisc-=ok;
      break;
      case 'R': 
        ok=1; 
        for (i=0;i<4;i++) for (j=0;j<4;j++) if ((Hra->thisc)+j+1>=Hra->C) if (KOCKA[Hra->this][i][j]!='.') ok=0;
        Hra->thisc+=ok;
      break;          
      case 'T': 
        ok=1; nju=4*(Hra->this/4)+((Hra->this%4)+1)%4; 
        for (i=0;i<4;i++) for (j=0;j<4;j++) 
          if (KOCKA[nju][i][j]!='.') if (Hra->Plan[(Hra->thisr)+i][(Hra->thisc)+j]) ok=0;
        if (ok) Hra->this=nju;
      break;
      case 'D':
        ok=1;
        for (i=0;i<4;i++) for (j=0;j<4;j++) if (KOCKA[Hra->this][i][j]!='.') if (KOCKA[Hra->this][i+1][j]=='.') 
          if (Hra->Plan[Hra->thisr+i+1][Hra->thisc+j]) ok=0;
        Hra->thisr+=ok;
      break;
    }
    // vykresli 
  }
//  fprintf(stderr,"spracoval tah, ide padat na %d %d\n",Hra->thisr,Hra->thisc);
  // kym nie sme dole, padame
  ok=1;
  for (i=0;i<4;i++) for (j=0;j<4;j++) if (KOCKA[Hra->this][i][j]!='.') if (KOCKA[Hra->this][i+1][j]=='.') 
    if (Hra->Plan[(Hra->thisr)+i+1][(Hra->thisc)+j]) ok=0;
  while (ok){
    Hra->thisr++; ok=1;
    for (i=0;i<4;i++) for (j=0;j<4;j++) if (KOCKA[Hra->this][i][j]!='.') if (KOCKA[Hra->this][i+1][j]=='.') 
      if (Hra->Plan[(Hra->thisr)+i+1][(Hra->thisc)+j]) ok=0;
  }
//  fprintf(stderr,"dopadol na %d %d\n",Hra->thisr,Hra->thisc);
  for (i=0;i<4;i++) for (j=0;j<4;j++) 
    if (KOCKA[Hra->this][i][j]!='.') Hra->Plan[(Hra->thisr)+i][(Hra->thisc)+j]=KOCKA[Hra->this][i][j];
  
  // odobrat riadky pridat body
  for (kr=0,kc=0;kr<Hra->R;kr++) {
    ok=1; for (i=0;i<Hra->C;i++) if (!Hra->Plan[kr][i]) { ok=0; break; }
    if (ok){
      kc++; 
      for (i=kr-1;i>=0;i--) for (j=0;j<Hra->C;j++) Hra->Plan[i+1][j]=Hra->Plan[i][j];
      for (j=0;j<Hra->C;j++) Hra->Plan[0][j]=0;
    }
  }
  Hra->lines+=kc; Hra->score+=kc*kc;
  
  Hra->this=Hra->next;
  Hra->next=(rand()%7)*4;
  Hra->thisr=Hra->thisc=0;
  
  //usleep(100000);
  if (!SILENT) Kresli(Hra);
}	

void SpustiHraca(void) {
  int fds1[2],fds2[2];
  if (pipe(fds1)||pipe(fds2)) {
    fprintf(stderr,"Cannot launch the tested program.\n");	  
    exit(2);	  
    }
  fclose(stdin); fclose(stdout);
  child=fork();
  if (child==-1) {
    fprintf(stderr,"Cannot launch the tested program.\n");	  
    exit(2);	  
    }	  
  if (child) {
    if ((dup2(fds1[0],0)==-1)||(dup2(fds2[1],1)==-1)) {
      fprintf(stderr,"Cannot launch the tested program.\n");	  
      exit(2);	  
      }
    close(fds1[0]); close(fds1[1]); close(fds2[0]); close(fds2[1]);
    stdin = fdopen(0, "r");
    stdout = fdopen(1, "w");
    setvbuf(stdin, NULL, _IONBF, 0);
    setvbuf(stdout, NULL, _IONBF, 0);
    return;
    }	  
  if ((dup2(fds2[0],0)==-1)||(dup2(fds1[1],1)==-1)) {
    fprintf(stderr,"Cannot launch the tested program.\n");	  
    exit(2);	  
    }
  close(fds1[0]); close(fds1[1]); close(fds2[0]); close(fds2[1]);
  execl("./player","player","xyzzy",NULL);
  fprintf(stderr,"Cannot launch the tested program.\n");
  exit(2);
}
  
int main(int argc,char **argv) {
  while (argc>1) {
    if (!strcmp(argv[argc-1],"-q")) SILENT=1;
    argc--;
  }
  
  SpustiHraca();
  NovaHra(&Hra);
  while (1) SpracujTah(&Hra);
  fprintf(stderr,"Okay!\n");
  return 0;
}
