#include <pvm3.h>
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "const.h"
// #include "kocky.h"
#include "tetris.h"
#define xSERIAL 1
#define xSILENT 1

int POCET;
TTah TAHY[100];
int TahValue[100];
int NEXTJOB[10],NEXTMJOB;
int *Workers;

int MoveToNextJob(){
  int k,ok;
  for (k=1,ok=0;k<=HLBKA_BT;k++) if (NEXTJOB[k]!=6) { ok=1; break; }
  if (!ok) if (NEXTMJOB<POCET-1) {
    for (k=1;k<=HLBKA_BT;k++) NEXTJOB[k]=0;
    return 2;
  }
  if (!ok) return 0;
  k=HLBKA_BT; while (NEXTJOB[k]==6) NEXTJOB[k--]=0; 
  NEXTJOB[k]++;
  return 1;
}

int IShallGiveUp(void){
  FILE *f;
  f=fopen("giveup","r");
  if (f==NULL) return 0;
  fclose(f); remove("giveup");
  return 1;
}

void SendWork(int komu, THra *Hra, int noTahu) {
  int i;
#ifndef SILENT
//  fprintf(stderr,"Posielam workerovi #%02d kocky: ",komu);
//  for (i=0;i<=HLBKA_BT;i++) fprintf(stderr,"%d ",NEXTJOB[i]);
//  fprintf(stderr,"a mjob %d\n",noTahu);
#endif

  pvm_initsend(PvmDataDefault);
  pvm_pkint(&noTahu,1,1);
  for (i=0;i<=HLBKA_BT;i++) pvm_packf("%d",NEXTJOB[i]);
  pvm_pkbyte(&Hra->Plan[0][0],50*25,1);
  pvm_pkint(&Hra->R,1,1); 
  pvm_pkint(&Hra->C,1,1);
  pvm_pkint(&Hra->score,1,1);
// typedef struct { char Plan[50][25]; int R,C; int this,next; int score,lines,moves; int thisr,thisc; } THra;
  
  pvm_send(Workers[komu],MSG_REQUEST);
}

int main(int argc, char **argv) {
  int wantWorkers, gotWorkers, doneWorkers=0;
  char hostname[100];
  int i,j,pos,best,kde;
  int workleft;
  THra Hra,pomHra;
  int bufid,buflen,buftag,buftid,bufdoslo,bufkto,buftah;

  if ((argc<2)||(strcmp(argv[1],"xyzzy"))) 
    { fprintf(stderr,"PVMtris player: Please launch \"arbiter\" instead...\n"); return 0; }
  
  // uvodne udaje        
  gethostname(hostname,100);
#ifndef SILENT
  fprintf(stderr,"player: @%s\n",hostname);
#endif

#ifndef SERIAL
  // nastartujeme workerov
  wantWorkers=POCET_WORKEROV;
  Workers=(int *)malloc(wantWorkers*sizeof(int));
  gotWorkers=pvm_spawn("worker",(char **)0,PvmTaskDefault,"",wantWorkers,Workers);
  if (!gotWorkers) { fprintf(stderr,"PVMtris player: unable to spawn workers\n"); return 2; }
#ifndef SILENT
  fprintf(stderr,"PVMtris player: wanted %d workers, got %d\n",wantWorkers,gotWorkers); 
#endif

  // posleme im poradove cisla
  for (i=0;i<gotWorkers;i++){
    pvm_packf("%+%d",PvmDataDefault,i);
    pvm_send(Workers[i],MSG_ENROLL);
  }

  // pockame kym sa prihlasia 
  for(i=0;i<gotWorkers;i++) {
    pvm_recv(-1,MSG_ACK);
    pvm_upkint(&pos,1,1);
    pvm_upkstr(hostname);
#ifndef SILENT
    fprintf(stderr,"worker #%02d [task_id #%x] @%s\n",pos,Workers[pos],hostname);
#endif
  }
#endif
  
  // nacitame rozmery sachty
  scanf("nova hra %d %d",&Hra.R,&Hra.C);
  bzero(Hra.Plan,sizeof(Hra.Plan));
  for (i=0;i<Hra.C;i++) Hra.Plan[Hra.R][i]='x';
  Hra.score=Hra.lines=Hra.moves=0;
  Hra.thisr=Hra.thisc=0;

  // gamesime 
  while (1) {
    // nacitame najblizsie dve kocky 
    scanf("%d %d",&Hra.this,&Hra.next);
    if (Hra.this==-1) break; // koncime, prehrali sme :)
    if (IShallGiveUp()) {
      fprintf(stderr,"Ending the game on user's request\n");
      break;
    }
    
    // najdeme vsetky mozne umiestnenia prvej kocky
    NajdiTahy(&Hra,&POCET,TAHY);
    
    // pre kazde umiestnenie prvej kocky rozosielame robotu typu:
    // Hra druha_kocka k1 k2 [k3]
    // zaujima nas, ako najlepsie vieme umiestnit tieto 3+ kocky
    // z vysledkov vsetkych zoberieme strednu hodnotu, vyberieme to umiestnenie prvej kocky, pre
    // ktore je maximalna
    best=-20000; kde=0;
#ifndef SERIAL
    // inicializujeme premenne
    NEXTMJOB=0; NEXTJOB[0]=Hra.next/4;
    for (j=1;j<=HLBKA_BT;j++) NEXTJOB[j]=0;
    for (j=0;j<POCET;j++) TahValue[j]=470000000;
    doneWorkers=0; workleft=1; 
    memcpy(&pomHra,&Hra,sizeof(Hra)); SpravTah(&pomHra,TAHY[0]);
    // rozosleme zaciatocnu pracu
    for (j=0;j<gotWorkers;j++) {
      if (workleft) { 
        SendWork(j,&pomHra,NEXTMJOB); 
        workleft=MoveToNextJob();
        if (workleft==2) { NEXTMJOB++; memcpy(&pomHra,&Hra,sizeof(Hra)); SpravTah(&pomHra,TAHY[NEXTMJOB]); }
      } else doneWorkers++;
    }
    // kym jesto, rozdavame dalej
    while (doneWorkers < gotWorkers) {
      bufid=pvm_recv(-1,MSG_REPLY);
      pvm_bufinfo(bufid,&buflen,&buftag,&buftid);
      pvm_unpackf("%d %d %d ",&bufkto,&buftah,&bufdoslo);
//      fprintf(stderr,"Od workera %02d dosla k tahu %d hodnota %d\n",bufkto,buftah,bufdoslo);
      if (bufdoslo<TahValue[buftah]) TahValue[buftah]=bufdoslo;
      
      if (workleft) {
        SendWork(bufkto,&pomHra,NEXTMJOB);
        workleft=MoveToNextJob();
        if (workleft==2) { NEXTMJOB++; memcpy(&pomHra,&Hra,sizeof(Hra)); SpravTah(&pomHra,TAHY[NEXTMJOB]); }
      } else doneWorkers++;
    }
    // a pozrieme, co nam vyslo
//    for (i=0;i<POCET;i++) fprintf(stderr,"TAHY[%2d]=%s\n",i,TAHY[i]); 
    for (i=0;i<POCET;i++) if (TahValue[i]>best) { best=TahValue[i]; kde=i; }
#else
    for (i=0,kde=0;i<POCET;i++) {
      memcpy(&pomHra,&Hra,sizeof(Hra));
      SpravTah(&pomHra,TAHY[i]);
      pos=HodnotHru(&pomHra);
      if (pos>best) { best=pos; kde=i; }
    }
#endif

    // posleme arbitrovi najdeny tah
    printf("%s\n",TAHY[kde]); fflush(stdout);
    // interne si spravime tah
    SpravTah(&Hra,TAHY[kde]);
  }
  
#ifndef SERIAL
  // POZABIJAME 
  for(i=0;i<gotWorkers;i++) {
    pvm_initsend(PvmDataDefault);
    pvm_send(Workers[i],MSG_CLOSE);
  }
#endif

  return 0;
}
